## icon 9.5.24a

=== tests/Makefile ===
#  Makefile for testing Icon


#  The default is to run all tests.

Test    Test-icont:	; cd general; $(MAKE) Test
Samples Samples-icont:	; cd general; $(MAKE) Samples


#  Clean up.

Clean Pure:
	cd bench;	$(MAKE) Clean
	cd general;	$(MAKE) Clean
	cd special;	$(MAKE) Clean

=== src/common/Makefile ===
include ../../Makedefs


OBJS =	long.o getopt.o time.o filepart.o identify.o strtbl.o rtdb.o\
	munix.o literals.o rswitch.o alloc.o long.o getopt.o time.o\
	xwindow.o ipp.o

common:		$(OBJS)

patchstr:	patchstr.c
		$(CC) $(CFLAGS) -o patchstr patchstr.c

wincap:		
		cd ../wincap; $(MAKE) libWincap.a
		cp -u ../wincap/libWincap.a ../../bin/libIgpx.a

$(OBJS): ../h/define.h ../h/arch.h ../h/config.h ../h/cstructs.h \
	  ../h/typedefs.h ../h/mproto.h ../h/cpuconf.h

../h/arch.h:	infer.c
		$(CC) $(CFLAGS) -o infer infer.c
		./infer >../h/arch.h

identify.o: ../h/version.h

ipp.o: ../h/features.h

literals.o: ../h/esctab.h

rtdb.o: ../h/version.h icontype.h

xwindow.o: ../h/graphics.h ../h/xwin.h


#  The following section is needed if changes are made to the Icon grammar,
#  but it is not run as part of the normal installation process.  If it is
#  needed, it is run by changing ../icont/Makefile; see the comments there
#  for details.  icont must be in the search path for this section to work.

gfiles:			lextab.h yacctok.h fixgram pscript

lextab.h yacctok.h:	tokens.txt op.txt mktoktab
			./mktoktab

mktoktab:		mktoktab.icn
			icont -s mktoktab.icn

fixgram:		fixgram.icn
			icont -s fixgram.icn

pscript:		pscript.icn
			icont -s pscript.icn



#  The following section is commented out because it does not need to be
#  performed unless changes are made to typespec.txt. Such changes
#  and are not part of the installation process.  However, if the
#  distribution files are unloaded in a fashion such that their dates
#  are not set properly, the following section would be attempted.
#
#  Note that if any changes are made to the file mentioned above, the
#  comment characters at the beginning of the following lines should be
#  removed.
#
#  Note that icont must be on your search path for this.
#
#
#icontype.h: typespec.txt typespec
#	typespec <typespec.txt >icontype.h
#
#typespec: typespec.icn
#	icont typespec

=== ipl/packs/idol/Makefile ===
#
# Sample makefile for compiling Idol
#
idol: idol.iol idolmain.u1 unix.u1 idolboot
	./idolboot idol unix.u1 idolmain.u1

idolboot: idolboot.icn unix.u1
	icont -s idolboot unix.u1

unix.u1: unix.icn
	icont -s -c unix

idolmain.u1: idolmain.icn
	icont -s -c idolmain


#  Build executable and copy to ../../iexe.
#  (Nothing done in this case because the executable doesn't stand alone.)
Iexe:


Clean:
	rm -rf *.u[12] idol idolboot idolmain unix idolcode.env

=== debian/changelog ===
icon (9.5.24a-1) unstable; urgency=medium

  * QA upload.

  [ Mechtilde ]
  * [e465b09] New upstream version 9.5.24a
  * [c1dc9ce] Updated patches for new upstrem version
  * [88732a1] Improved d/p/001-*.patch
  * [0db176e] Additional dependency libxpm-dev

 -- Mechtilde Stehmann <mechtilde@debian.org>  Fri, 02 Aug 2024 20:11:30 +0200

icon (9.4.3-8) unstable; urgency=medium

  * QA upload.

  [ Vagrant Cascadian ]
  * debian/rules: Add -ffile-prefix-map to CFLAGS to avoid embedded
    build paths. Adjust call to sed to handle "/" in the expression
    (Closes: #1021461).

  [ Petter Reinholdtsen ]
  * Added d/gbp.conf to describe branch layout.
  * Updated vcs in d/control to Salsa.
  * Updated d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 3.6.2 to 4.7.0.
  * Use wrap-and-sort -at for debian control files
  * Trim trailing whitespace.
  * Added Homepage to d/control.
  * Added d/watch to track upstream from github.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 03 Jun 2024 07:50:58 +0200

=== debian/control ===
Source: icon
Maintainer: Debian QA Group <packages@qa.debian.org>
Standards-Version: 4.7.0
Section: devel
Priority: optional
Build-Depends: libx11-dev,
               libxt-dev,
               libxpm-dev
Homepage: http://www.cs.arizona.edu/icon/
Vcs-Browser: https://salsa.debian.org/debian/icon
Vcs-Git: https://salsa.debian.org/debian/icon.git

Package: icont
Architecture: any
Depends: ${shlibs-icont:Depends},
Recommends: iconx,
Suggests: icon-ipl,
Description: Interpreter for Icon, a high-level programming language
 Ideal for both complex nonnumerical applications and for situations where
 users need quick solutions with a minimum of programming effort, Icon is a
 high-level, general purpose programming language with a syntax similar to
 Pascal and C. Its applications include: rapid prototyping, analyzing
 natural languages, generating computer programs, and artificial
 intelligence. (From the back cover of the book "The Icon Programming
 Language," by Griswold and Griswold.)
 .
 This package contains the Icon translator, which converts Icon source code
 into `ucode` that can then be executed with the help of the iconx program.

Package: iconx
Architecture: any
Depends: ${shlibs-iconx:Depends},
Description: Executor for Icon, a high-level programming language
 Ideal for both complex nonnumerical applications and for situations where
 users need quick solutions with a minimum of programming effort, Icon is a
 high-level, general purpose programming language with a syntax similar to
 Pascal and C. Its applications include: rapid prototyping, analyzing
 natural languages, generating computer programs, and artificial
 intelligence. (From the back cover of the book "The Icon Programming
 Language," by Griswold and Griswold.)
 .
 This package contains the Icon executor, iconx, which is needed to execute
 interpreted Icon programs. If you are starting from Icon source code (as
 opposed to precompiled `ucode' files), you will also need the icont
 package, which converts your Icon source into a program that iconx can
 execute.

Package: icon-ipl
Architecture: all
Recommends: icont,
Description: Libraries for Icon, a high-level programming language
 Ideal for both complex nonnumerical applications and for situations where
 users need quick solutions with a minimum of programming effort, Icon is a
 high-level, general purpose programming language with a syntax similar to
 Pascal and C. Its applications include: rapid prototyping, analyzing
 natural languages, generating computer programs, and artificial
 intelligence. (From the back cover of the book "The Icon Programming
 Language," by Griswold and Griswold.)
 .
 This package contains the Icon program library, a library of Icon
 procedures and programs contributed by Icon users.

=== debian/rules ===
#!/usr/bin/make -f
#
# Do we make rt.a into an ELF library?
# Do we make iconx link with xpm.so?

DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null)

# The current code use type-punning and signed overflow
ifneq (,$(filter $(DEB_HOST_ARCH), sparc mips mipsel))
  CFLAGS_OPT = -O0
else
  CFLAGS_OPT = -O2 -fno-strict-aliasing -fno-strict-overflow
endif

ifneq (, $(filter $(DEB_HOST_ARCH_OS), linux kfreebsd knetbsd))
  system = linux
else
  ifeq ($(DEB_HOST_ARCH_OS),hurd)
    system = gnu
  else
    system = $(DEB_HOST_ARCH_OS)
  endif
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  CFLAGS_OPT = -O0
endif

CFLAGS = -Wall -g $(CFLAGS_OPT)

# Avoid embedding build paths for reproducible builds
CFLAGS += -ffile-prefix-map=$(CURDIR)=.

configure:
	$(MAKE) X-Configure name=$(system)
	sed "s%CFLAGS = .*%CFLAGS = $(CFLAGS)%" Makedefs > Makedefs.tmp
	echo "ASFLAGS = -Wa,--noexecstack" >> Makedefs.tmp
	mv Makedefs.tmp Makedefs
	touch $@

build-icont: configure
	$(MAKE) Icont
	touch $@

build-ipl: configure
	$(MAKE) Ilib
	touch $@

clean:
	rm -f configure build-icont build-ipl
	rm -rf debian/iconx debian/icont debian/icon-ipl debian/files debian/*~
	rm -f bin/* debian/substvars
	$(MAKE) Pure

binary-icont: build-icont
	rm -rf debian/icont
# Create the directory hierarchy.
	install -d debian/icont/usr/bin
	install -d debian/icont/DEBIAN
	install -d debian/icont/usr/share/man/man1
	install -d debian/icont/usr/share/doc/icont
# Copy the executables and documentation...
	install -s -m 755 bin/icont debian/icont/usr/bin
	ln -s icont debian/icont/usr/bin/icon
	install -m 644 man/man1/icon.1 debian/icont/usr/share/man/man1/icon.1
	install -m 644 man/man1/icont.1 debian/icont/usr/share/man/man1/icont.1
	sed -e 's/icon-dir/icont/g' debian/copyright \
		> debian/icont/usr/share/doc/icont/copyright
	install -m 644 debian/changelog \
		debian/icont/usr/share/doc/icont/changelog.Debian
# Patch icont...
#	bin/patchstr debian/icont/usr/bin/icont /usr/bin/iconx
# Wrap icont to provide default for IPATH and LPATH
#	mv debian/icont/usr/bin/icont debian/icont/usr/bin/icont.real
#	install -o root -g root -m 755 debian/icont-wrapper debian/icont/usr/bin/icont
# Compress documentation...
	gzip -9n debian/icont/usr/share/doc/icont/changelog.Debian
	gzip -9rn debian/icont/usr/share/man
#	cd debian/icont/usr/share/man/man1 && ln -sf icont.1.gz icont.real.1.gz
# Fix permissions...
	chmod -R u=rwX,go=rX debian/icont
	chown -R root:root debian/icont
# Make the debian control area.
	dpkg-shlibdeps -pshlibs-icont debian/icont/usr/bin/*
	dpkg-gencontrol -picont -Pdebian/icont
# And finally, build the Debian package!
	dpkg --build debian/icont ..

binary-iconx: build-icont
	rm -rf debian/iconx
# Create the directory hierarchy.
	install -d debian/iconx/usr/bin
	install -d debian/iconx/DEBIAN
	install -d debian/iconx/usr/share/man/man1
	install -d debian/iconx/usr/share/doc/iconx
# Copy the executables and documentation...
	install -s -m 755 bin/iconx debian/iconx/usr/bin
	install -m 644 man/man1/icon.1 debian/iconx/usr/share/man/man1/iconx.1
	sed -e 's/icon-dir/iconx/g' debian/copyright \
		> debian/iconx/usr/share/doc/iconx/copyright
	install -m 644 debian/changelog \
		debian/iconx/usr/share/doc/iconx/changelog.Debian
# Compress documentation...
	gzip -9n debian/iconx/usr/share/doc/iconx/changelog.Debian
	gzip -9rn debian/iconx/usr/share/man
# Fix permissions...
	chmod -R u=rwX,go=rX debian/iconx
	chown -R root:root debian/iconx
# Make the debian control area.
	dpkg-shlibdeps -pshlibs-iconx debian/iconx/usr/bin/*
	dpkg-gencontrol -piconx -Pdebian/iconx
# And finally, build the Debian package!
	dpkg --build debian/iconx ..

binary-ipl: build-ipl
	rm -rf debian/icon-ipl
# Create the directory hierarchy.
	install -d debian/icon-ipl/DEBIAN
	install -d debian/icon-ipl/usr/share/doc/icon-ipl
	install -d debian/icon-ipl/usr/lib/icon-ipl
# Copy Icon program library...
	cp -r lib/* ipl/procs/*.icn ipl/gprocs/*.icn debian/icon-ipl/usr/lib/icon-ipl
# Copy copyright information.
	sed -e 's/icon-dir/icon-ipl/g' debian/copyright \
		> debian/icon-ipl/usr/share/doc/icon-ipl/copyright
	install -m 644 debian/changelog \
		debian/icon-ipl/usr/share/doc/icon-ipl/changelog.Debian
# Compress documentation...
	gzip -9n debian/icon-ipl/usr/share/doc/icon-ipl/changelog.Debian
	find debian/icon-ipl/usr/share/doc/icon-ipl -type f -size +6k -print | \
		xargs --no-run-if-empty gzip -9n
# Fix permissions...
	chmod -R u=rwX,go=rX debian/icon-ipl
	chown -R root:root debian/icon-ipl
# Make the debian control area.
	dpkg-gencontrol -picon-ipl -Pdebian/icon-ipl
# And finally, build the Debian package!
	dpkg --build debian/icon-ipl ..

test: build-icont build-ipl
	@echo Tests for the Icon interpreter.
	@echo First some simple tests to be sure Icon works.
	$(MAKE) Samples-icont
	@echo More exhaustive tests of various features of Icon and larger programs.
	@echo  1. Basic tests. Should show only insignificant differences.
	$(MAKE) Test-icont

benchmark: build-icont
	$(MAKE) Benchmark-icont	

build-arch: build
build-indep: build
build-iconx: build-icont
build: build-icont build-ipl test

binary-arch: binary-icont binary-iconx

binary-indep: binary-ipl

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean build build-arch build-indep test benchmark

## icon 9.5.24b

=== config/Makefile ===
#  Makefile for cleaning up after setup.sh

TOP = ..
SRC = $(TOP)/src


Clean:

Pure:
	rm -f $(TOP)/Makedefs
	rm -f $(SRC)/h/define.h

=== doc/Makefile ===
#  Makefile for FAQ/doc installation and webpage validation
#  <<ARIZONA-ONLY>>
#
#  This Makefile is for Icon maintenance and FAQ installation at Arizona.
#  Because of that it is targeted for the Icon development environment
#  (Mac OS X plus some specialized tools) and is less portable than
#  other Makefiles.

MADE = icon.txt icont.txt

SERVER = lectura.cs.arizona.edu
PUBDIR = /cs/www/icon/uguide


#  (default:) rebuild icon.txt, icont.txt, and faq.txt from nroff/html sources.

default:  $(MADE)

icon.txt: ../man/man1/icon.1 clnroff.sed
	nroff -Tascii -man ../man/man1/icon.1 | \
	    sed -f clnroff.sed | uniq >icon.txt

icont.txt: ../man/man1/icont.1 clnroff.sed
	nroff -Tascii -man ../man/man1/icont.1 | \
	    sed -f clnroff.sed | uniq >icont.txt


#  install updated files on the Icon website.

publish: $(MADE)
	scp *.css *.gif *.jpg *.txt *.htm $(SERVER):$(PUBDIR)


#  remove built files to force a rebuild.
#  do NOT do this before preparing an Icon distribution.

Clean clean:
	rm -f $(MADE)

=== src/Makefile ===
#  Icon source Makefile, normally used only for cleanup.


what:
	@echo "What do you want to make?"

Clean Pure:
	cd common;	rm -f *.o *.exe patchstr infer
	cd preproc;	rm -f *.o *.exe pp
	cd rtt;		rm -f *.o *.exe rtt
	cd runtime;	rm -f *.o *.exe *.c rt.db rt.a rtt*.lst iconx
	cd icont;	rm -f *.o *.exe icont hdr.h ixhdr.hdr newhdr
	cd wincap;	rm -f *.o *.exe *.a
# force full runtime system rebuild
	touch -c h/define.h
	rm -f h/arch.h


#  The following entry forces rebuilding of everthing from first-generation
#  files, even files not normally recreated.  Doing this requires uncommenting
#  some lines in common/Makefile and icont/Makefile.

Force-rebuild: Clean
	cd h; rm -f kdefs.h
	cd common; rm -f *.o yacctok.h lextab.h icontype.h \
		fixgram mktoktab patchstr pscript typespec
	cd icont; rm -f *.o icont mkkwd trash \
		hdr.h keyword.h tgram.g ttoken.h tparse.c

=== ipl/cfuncs/Makefile ===
#  Makefile for the dynamically loaded C function library.
#
#  If building with the compiler (instead of the interpreter)
#  use the "-fs" option to avoid problems.


include ../../Makedefs

ICONT = icont
IFLAGS = -us

FUNCLIB = libcfunc.so

.SUFFIXES: .c .o
.c.o:			; $(CC) $(CFLAGS) $(CFDYN) -c $<

FUNCS = bitcount.o external.o files.o fpoll.o internal.o lgconv.o osf.o \
	pack.o ppm.o process.o tconnect.o
CSRC = $(FUNCS:.o=.c)


default:	cfunc.u2 $(FUNCLIB)


# library

$(FUNCLIB):	$(FUNCS) mklib.sh
		CC="$(CC)" CFLAGS="$(CFLAGS)" BIN="../../bin" \
		    sh mklib.sh $(FUNCLIB) $(FUNCS)
$(FUNCS):	icall.h


# Icon interface

cfunc.u2:	cfunc.icn
		$(ICONT) $(IFLAGS) -c cfunc.icn
cfunc.icn:	$(CSRC) mkfunc.sh
		sh mkfunc.sh $(FUNCLIB) $(FUNCS) >cfunc.icn


# cleanup

clean Clean:
		rm -f $(FUNCLIB) *.o *.u? *.so so_locations cfunc.icn

=== src/icont/Makefile ===
#  Makefile for the Icon translator, icont.

include ../../Makedefs


HFILES =	../h/define.h ../h/config.h ../h/cpuconf.h ../h/gsupport.h \
		   ../h/mproto.h ../h/typedefs.h ../h/cstructs.h

TRANS =		trans.o tcode.o tlex.o lnklist.o tparse.o tsym.o tmem.o tree.o

LINKR =		link.o lglob.o lcode.o llex.o lmem.o lsym.o opcode.o

OBJS =		tunix.o tglobals.o util.o $(TRANS) $(LINKR)

COBJS =		../common/long.o ../common/getopt.o ../common/alloc.o \
		   ../common/filepart.o ../common/strtbl.o ../common/ipp.o \
		   ../common/munix.o



icont:		$(OBJS) $(COBJS)
		$(CC) $(CFLAGS) $(LDFLAGS) -o icont $(OBJS) $(COBJS)
		rm -f ../../bin/icont$(EXE)
		cp icont ../../bin
		strip ../../bin/icont$(EXE)
		(cd ../../bin; rm -f icon icon.exe; ln -s icont icon)

$(OBJS):	$(HFILES) tproto.h

$(COBJS):	$(HFILES)
		cd ../common; $(MAKE)

tunix.o:	tglobals.h ../h/version.h
tglobals.o:	tglobals.h
util.o:		tglobals.h tree.h ../h/fdefs.h

# translator files
trans.o:	tglobals.h tsym.h ttoken.h tree.h ../h/version.h ../h/kdefs.h
lnklist.o:	lfile.h
tparse.o:	../h/lexdef.h tglobals.h tsym.h tree.h keyword.h
tcode.o:	tglobals.h tsym.h ttoken.h tree.h
tlex.o:		../h/lexdef.h ../h/parserr.h ttoken.h tree.h ../h/esctab.h \
		   ../common/lextab.h ../common/yylex.h ../common/error.h
tmem.o:		tglobals.h tsym.h tree.h
tree.o:		tree.h
tsym.o:		tglobals.h tsym.h ttoken.h lfile.h keyword.h ../h/kdefs.h

# linker files
$(LINKR):	link.h lfile.h ../h/rt.h ../h/sys.h \
		   ../h/rstructs.h ../h/rmacros.h ../h/rexterns.h

link.o:		tglobals.h hdr.h ../h/header.h
lcode.o:	tglobals.h opcode.h keyword.h ../h/header.h \
			../h/opdefs.h ../h/version.h
lglob.o:	tglobals.h opcode.h ../h/opdefs.h ../h/version.h
llex.o:		tglobals.h opcode.h ../h/opdefs.h
lmem.o:		tglobals.h
lsym.o:		tglobals.h
opcode.o:	opcode.h ../h/opdefs.h

#  hdr.h is always built, to simplify the Makefile,
#  but it is only actually used if BinHeader is define.
hdr.h:		newhdr ixhdr.hdr
		./newhdr -o hdr.h ixhdr.hdr
newhdr:		newhdr.c ../h/define.h ../h/config.h ../h/gsupport.h
		$(CC) $(CFLAGS) $(LDFLAGS) -o newhdr newhdr.c
ixhdr.hdr:	ixhdr.c ../h/define.h ../h/config.h ../h/header.h $(COBJS)
		$(CC) $(CFLAGS) $(LDFLAGS) -o ixhdr.hdr \
			ixhdr.c ../common/alloc.o ../common/munix.o
		strip ixhdr.hdr




#  The following sections are commented out because they do not need to be
#  performed unless changes are made to cgrammar.c, ../h/grammar.h,
#  ../common/tokens.txt, or ../common/op.txt.  Such changes involve
#  modifications to the syntax of Icon and are not part of the installation
#  process. However, if the distribution files are unloaded in a fashion
#  such that their dates are not set properly, the following sections would
#  be attempted.
#
#  Note that if any changes are made to the files mentioned above, the comment
#  characters at the beginning of the following lines should be removed.
#  icont must be on your search path for these actions to work.
#
#../common/lextab.h ../common/yacctok.h ../common/fixgram ../common/pscript: \
#			../common/tokens.txt ../common/op.txt
#		cd ../common; $(MAKE) gfiles
#
#tparse.c ttoken.h:	tgram.g trash ../common/pscript
## expect 218 shift/reduce conflicts
#		yacc -d tgram.g
#		./trash <y.tab.c | ../common/pscript >tparse.c
#		mv y.tab.h ttoken.h
#		rm -f y.tab.c
#
#tgram.g:	tgrammar.c ../h/define.h ../h/grammar.h \
#			../common/yacctok.h ../common/fixgram 
#		$(CC) -E -C tgrammar.c | ../common/fixgram >tgram.g
#
#../h/kdefs.h keyword.h:	../runtime/keyword.r mkkwd
#		./mkkwd <../runtime/keyword.r
#
#trash:		trash.icn
#		icont -s trash.icn
#
#mkkwd:		mkkwd.icn
#		icont -s mkkwd.icn

=== src/rtt/Makefile ===
#  Makefile for the Icon run-time translator, rtt,
#  which is used to build the Icon run-time system.

include ../../Makedefs


ROBJS = rttparse.o rttmain.o rttlex.o rttsym.o rttnode.o rttout.o rttmisc.o\
	  rttdb.o rttinlin.o rttilc.o

PP_DIR = ../preproc/
P_DOT_H = $(PP_DIR)preproc.h $(PP_DIR)pproto.h ltoken.h ../h/mproto.h\
        ../h/define.h ../h/config.h ../h/typedefs.h\
        ../h/cstructs.h ../h/cpuconf.h
POBJS = pout.o pchars.o  perr.o pmem.o  bldtok.o macro.o preproc.o\
	evaluate.o files.o gettok.o pinit.o

COBJS = ../common/getopt.o ../common/time.o ../common/filepart.o \
	  ../common/identify.o ../common/strtbl.o ../common/alloc.o \
	  ../common/rtdb.o ../common/munix.o ../common/literals.o

OBJ = $(ROBJS) $(POBJS) $(COBJS)


rtt:	$(OBJ)
	$(CC) $(LDFLAGS) -o rtt $(OBJ)

library:	$(OBJ)
		rm -rf rtt.a
		ar qc rtt.a $(OBJ)

$(COBJS):
	cd ../common; $(MAKE)

$(ROBJS): rtt.h rtt1.h rttproto.h $(P_DOT_H)

rttdb.o: ../h/version.h
rttparse.o : ../h/gsupport.h ../h/config.h ../h/cstructs.h \
	../h/mproto.h ../h/typedefs.h ../h/cpuconf.h ../h/define.h

pout.o: $(PP_DIR)pout.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)pout.c 

pchars.o: $(PP_DIR)pchars.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)pchars.c 

perr.o: $(PP_DIR)perr.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)perr.c

pmem.o: $(PP_DIR)pmem.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)pmem.c

bldtok.o: $(PP_DIR)bldtok.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)bldtok.c

macro.o: $(PP_DIR)macro.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)macro.c

preproc.o: $(PP_DIR)preproc.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)preproc.c

evaluate.o: $(PP_DIR)evaluate.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)evaluate.c

files.o: $(PP_DIR)files.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)files.c

gettok.o: $(PP_DIR)gettok.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)gettok.c

pinit.o: $(PP_DIR)pinit.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)pinit.c

#
# The following entry is commented out because it is not normally
# necessary to recreate rttparse.c and ltoken.h unless the grammar
# in rttgram.y for the run-time langauge is changed. Recreating these
# files is not normally a part of the installation process. Note that
# on some systems, yacc may not have large enough internal tables to
# translate this grammar.
#
#rttparse.c ltoken.h: rttgram.y
#	yacc -d rttgram.y
#	fgrep -v -x "extern char *malloc(), *realloc();" y.tab.c > rttparse.c
#	rm y.tab.c
#	mv y.tab.h ltoken.h

=== src/runtime/Makefile ===
#  Makefile for the Icon run-time system.

include ../../Makedefs


HDRS = ../h/define.h ../h/arch.h ../h/config.h ../h/typedefs.h \
	  ../h/cstructs.h ../h/cpuconf.h ../h/grttin.h\
	  ../h/rmacros.h ../h/rexterns.h ../h/rstructs.h \
	  ../h/rproto.h ../h/mproto.h ../h/sys.h

GHDRS = ../h/graphics.h ../h/xwin.h ../h/mswin.h

COBJS =	../common/long.o ../common/time.o \
	../common/rswitch.o ../common/xwindow.o \
	../common/alloc.o ../common/filepart.o ../common/munix.o

XOBJS =	cnv.o data.o def.o errmsg.o fconv.o fload.o fmath.o\
	fmisc.o fscan.o fstr.o fstranl.o fstruct.o fsys.o\
	fwindow.o imain.o imisc.o init.o interp.o invoke.o\
	keyword.o lmisc.o oarith.o oasgn.o ocat.o ocomp.o\
	omisc.o oref.o oset.o ovalue.o profile.o ralc.o rcoexpr.o rcomp.o\
	rdebug.o rexternal.o rlrgint.o rmemmgt.o rmisc.o rstruct.o \
	rsys.o rwinrsc.o rwinsys.o rwindow.o rcolor.o rimage.o

RTT = ../rtt/rtt
.SUFFIXES: .o .r .c
.r.o:	; $(RTT) -x $*.r && $(CC) -o $*.o -c $(CFLAGS) x$*.c && rm x$*.c
.r.c:	; $(RTT) -x $*.r


iconx: $(COBJS) $(XOBJS)
	cd ../common; $(MAKE)
	$(CC) $(RLINK) -o iconx $(XOBJS) $(COBJS) $(XL) $(RLIBS) $(TLIBS)
	rm -f ../../bin/iconx$(EXE)
	cp iconx ../../bin
	strip $(SFLAGS) ../../bin/iconx$(EXE)

$(COBJS):
	cd ../common; $(MAKE)


$(XOBJS): $(HDRS) $(GHDRS)

data.o:  ../h/fdefs.h ../h/odefs.h ../h/kdefs.h

fmisc.o: ../h/opdefs.h 

imain.o: ../h/version.h ../h/header.h ../h/opdefs.h ../h/version.h

init.o:  ../h/header.h ../h/odefs.h ../h/version.h

keyword.o:  ../h/kdefs.h ../h/features.h ../h/version.h

rdebug.o:   ../h/opdefs.h

rwinrsc.o:  rxrsc.ri

rwinsys.o:  rxwin.ri rmswin.ri

=== src/wincap/Makefile ===
# Makefile for creating a library of the parts of Wincap used by Icon.

include ../../Makedefs

W32DEFS = -mwin32
OBJS = copy.o dibutil.o errors.o file.o

.c.o:
	$(CC) -c $(CFLAGS) $(W32DEFS) $*.c

libWincap.a: $(OBJS)
	rm -f $@
	ar qc $@ $(OBJS)

copy.o: copy.c dibapi.h dibutil.h errors.h

dibutil.o: dibutil.c dibutil.h

errors.o: errors.c errors.h

file.o: file.c  dibapi.h dibutil.h errors.h

Clean:
	rm -f *.o *.a

=== tests/bench/Makefile ===
default:	benchmark


micro microbench microbenchmark:
		../../bin/icon micro.icn >micro.out 
		../../bin/icon micsum.icn micro.out >micro.sum
		cat micro.sum

benchmark:
		$(MAKE) benchmark-icont

benchmark-icont:
		$(MAKE) translate-icont compile-icont run-icont check-icont

translate-icont:
		sh Trans-icont post options shuffle

compile-icont:
		sh Comp-icont concord deal ipxref queens rsg

run-icont:
		sh Execute-icont

rerun-icont:
		sh ReRun-icont

check-icont:
		grep elapsed *-t.out

Clean:
		rm -f *.out *.sum *-t *.u?

=== ipl/packs/ibpag2/Makefile ===
##########################################################################
#
   PROGNAME = ibpag2
#
##########################################################################
#
#  User-modifiable section.  Read carefully!  You will almost
#  certainly have to change some settings here.
#

#
# Destination directory for binaries files.  Owner and group for
# public executables.  Leave the trailing slash off of directory
# names.
#
OWNER = richard # root
GROUP = group   # root
DESTDIR = /usr/local/bin
# Put this path into your LPATH variable (on which, see the Icon
# documentation).  Make sure that the directory exists.
LIBDIR = /usr/local/lib/icon/data

#
# Name of your icon compiler and compiler flags.
#
ICONT = icont
IFLAGS = -u -s #-Sc 400 -Sg 400 -Si 2000 -Sn 4000 -SF 40

SHAR = /usr/local/bin/shar
COMPRESS = /usr/bin/compress
# COMPRESS = /usr/local/bin/gzip

###########################################################################
#
#  Don't change anything below this line unless you're really sure of
#  what you're doing.
#

AUX = slshupto.icn rewrap.icn outbits.icn sortff.icn itokens.icn
SRC = $(PROGNAME).icn $(AUX) slrtbls.icn slritems.icn follow.icn \
	ibutil.icn iohno.icn ibreader.icn ibwriter.icn shrnktbl.icn \
	version.icn
PARSER = iiparse.lib
GLRPARSER = iiglrpar.lib
SHARFILES = $(SRC) $(PARSER) $(GLRPARSER) sample.ibp beta2ref.ibp \
	iacc.ibp Makefile.dist README

all: $(PROGNAME)

$(PROGNAME): $(SRC)
	$(ICONT) $(IFLAGS) -o $(PROGNAME) $(SRC)


##########################################################################
#
#  Pseudo-target names (shar, install, clean, clobber)
#

#
# Assumes you have a shar program like mine.
#
shar: $(SHARFILES)
	@echo ""
	@echo "Removing any old shars in this directory."
	@echo ""
	-rm -f $(PROGNAME).[0-9][0-9].Z
	@echo ""
	$(SHAR) -fVc -o$(PROGNAME) -L32 $(SHARFILES)
	$(COMPRESS) -f $(PROGNAME).[0-9][0-9]
	@echo ""
	@echo "Shell archive finished."
	@echo ""

# Pessimistic assumptions regarding the environment (in particular,
# I don't assume you have the BSD "install" shell script).
install: all
	@echo ""
	-test -d $(DESTDIR) || mkdir $(DESTDIR) && chmod 755 $(DESTDIR)
	cp $(PROGNAME) $(DESTDIR)/$(PROGNAME)
	-chgrp $(GROUP) $(DESTDIR)/$(PROGNAME)
	-chown $(OWNER) $(DESTDIR)/$(PROGNAME)
	-chmod 755 $(DESTDIR)/$(PROGNAME)
	-test -d $(LIBDIR) || mkdir $(LIBDIR) && chmod 755 $(LIBDIR)
	cp $(PARSER) $(LIBDIR)/$(PARSER)
	cp $(GLRPARSER) $(LIBDIR)/$(GLRPARSER)
	-chgrp $(GROUP) $(LIBDIR)/$(PARSER)
	-chown $(OWNER) $(LIBDIR)/$(PARSER)
	-chgrp $(GROUP) $(LIBDIR)/$(GLRPARSER)
	-chown $(OWNER) $(LIBDIR)/$(GLRPARSER)
	-chmod 644 $(LIBDIR)/$(PARSER)
	-chmod 644 $(LIBDIR)/$(GLRPARSER)
	@echo ""
	@echo "Done installing."
	@echo ""

#  Build executable and copy to ../../iexe.
#  Nothing done in this case because the executable doesn't stand alone.
Iexe:	


#
# Cleanup
#
clean:
	-rm -f *~ #*# core *.u[12] $(PROGNAME).output
Clean clobber: clean
	-rm -f $(PROGNAME)

=== ipl/packs/itweak/Makefile ===
############################################################################ 
#
# Unix Makefile for installing itweak and running a sample debugging session.
#
# updated 4-aug-2000/gmt
#
# 'make' or 'make install'
# does the necessary compilations to get the itweak package ready to use.
# Note, however, that it leaves the resulting files in the current directory.
# You must move or copy them yourself if you want them any other place.
# (See the documentation.)
#
# 'make sample-debug'
# compiles, tweaks, and links a sample program to make it ready for a
# debugging session.
# Assumes the 'dbg_run.u?' files are on your IPATH or in the current directory
# which is the case if you haven't moved things around since 'make install'.
#
# The sample executable is named 'sample'.
# The program is, however, identical 'ipxref' copied from the Icon Library.
# It also requires 'options.icn' (included), so the program is built from two
# source files.
#
# 'make demo'
# runs a debugging session with the sample program.
# It is uncommon to run debugging sessions from a Makefile.
# This is only for demo purposes.
#
# This makefile is in itself an example of how to construct makefiles.
# It provides a simple way to switch between a clean (untweaked) version
# and a tweaked version of the sample program without duplicating a lot of
# makefile code.
# Use 'make sample-clean' to force compilation of a clean (untweaked) copy of
# 'sample'.
#
############################################################################ 
# 
# Copyright (c) 1994 Hakan Soderstrom and
# Soderstrom Programvaruverkstad AB, Sweden
# 
# Permission to use, copy, modify, distribute, and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice and this permission notice
# appear in all copies of the software and related documentation.
# 
# THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
# EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
# WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
#
# IN NO EVENT SHALL HAKAN SODERSTROM OR SODERSTROM PROGRAMVARUVERKSTAD
# AB BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL
# DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
# OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY
# OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
############################################################################ 

ICONT=icont -s
ITWEAK=itweak


MAKEFILE=Makefile
SAMPLE_INIT=samp_ini.icn
CMD=demo.cmd

##### 'install' targets

install : itweak dbg_run.u1

itweak : itweak.icn
	$(ICONT) itweak.icn

dbg_run.u1 : dbg_run.icn
	$(ICONT) -c dbg_run.icn

##### 'sample' targets: first the plain ones
##### The program is built from source files 'ipxref.icn' and 'options.icn'.
##### The name of the resulting program is 'sample'.

sample : ipxref.u1 options.u1 $(DEBUG)
	$(ICONT) -u -o sample ipxref.u1 options.u1

ipxref.u1 : ipxref.icn
	$(ICONT) -cu ipxref.icn

options.u1 : options.icn
	$(ICONT) -cu options.icn

##### 'sample' targets: the debugging stuff

sample-debug :
	$(MAKE) -f $(MAKEFILE) sample DEBUG=$(SAMPLE_INIT)

$(SAMPLE_INIT) : ipxref.u1 options.u1
	@echo '*** This is how the program files are tweaked...'
	$(ITWEAK) -o $(SAMPLE_INIT) ipxref options
	@echo '*** ... and don't forget to compile the generated file.'
	$(ICONT) -cu $(SAMPLE_INIT)

sample-clean :
	rm -f ipxref.u? options.u?
	$(MAKE) -f $(MAKEFILE) sample

##### demo session

demo : sample-debug
	@echo 'We will now start a sample debugging session.'
	@echo 'Debugging commands will be taken from the file $(CMD).'
	@echo 'Please open an editor on this file -- the commands will'
	@echo 'not appear in the debugger output.'
	@echo '-------------- session start --------------------------'
	@(DBG_INPUT=$(CMD); export DBG_INPUT; sample ipxref.icn)
	@echo '-------------- session end ----------------------------'

##### build executable and copy to ../../iexe
##### (nothing done in this case because the executable doesn't stand alone)

Iexe :

##### cleanup

Clean :
	rm -f $(ITWEAK) *.u[12]

=== ipl/packs/loadfunc/Makefile ===
#  Makefile for programs illustrating dynamic loading of C functions from Icon
#
#  It is assumed that the standard C functions will be found by iconx.

include ../../../Makedefs
CFLAGS = -O $(CFDYN) -I../../cfuncs

ICONT = icont
IFLAGS = -us

.SUFFIXES: 	.icn
.icn:		; $(ICONT) $(IFLAGS) $<

MKLIB = ../../cfuncs/mklib.sh


PROGS = btest ddtest dldemo cspace tnet newsgrp
FUNCS = argdump.o cspgen.o ddump.o
FUNCLIB = libdemo.so



default: 	$(PROGS) $(FUNCLIB)

$(PROGS):	libnames.icn

libnames.icn:	Makefile
		echo '$$define FUNCLIB "./$(FUNCLIB)"'	>libnames.icn

$(FUNCLIB):	$(FUNCS)
		CC="$(CC)" CFLAGS="$(CFLAGS)" BIN="../../../bin" \
			sh $(MKLIB) $(FUNCLIB) $(FUNCS)


#  Copy progs to ../../iexe:
#  nothing done here because these executables require libraries
#  and don't stand alone
Iexe:


clean Clean:
		rm -f $(PROGS) $(FUNCLIB) *.o *.so *.u[12] libnames.icn

=== debian/changelog ===
icon (9.5.24b-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 21 Mar 2025 13:02:08 -0400

icon (9.5.24a-2) unstable; urgency=medium

  * QA upload.
  * Support building without (fake)root.

 -- Niels Thykier <niels@thykier.net>  Fri, 08 Nov 2024 09:25:34 +0000

## icon 9.5.25a

=== Makefile ===
#  Makefile for Version 9.5 of Icon
#
#  See doc/install.htm for instructions.
.POSIX:


#  configuration parameters
name=unspecified
dest=/must/specify/dest/


##################################################################
#
# Default targets.

All:	Icont Ilib Ibin
	bin/icon -V

config/$(name)/status src/h/define.h:
	:
	: To configure Icon, run either
	:
	:	make Configure name=xxxx     [for no graphics]
	: or	make X-Configure name=xxxx   [with X-Windows graphics]
	:
	: where xxxx is one of
	:
	@cd config; ls -d `find * -type d -prune -print`
	:
	@exit 1


##################################################################
#
# Code configuration.


# Configure the code for a specific system.

Configure:	config/$(name)/status
		$(MAKE) Pure >/dev/null
		cd config; sh setup.sh $(name) NoGraphics

X-Configure:	config/$(name)/status
		$(MAKE) Pure >/dev/null
		cd config; sh setup.sh $(name) Graphics


# Get the status information for a specific system.

Status:
		@cat config/$(name)/status


##################################################################
#
# Compilation.


# The interpreter: icont and iconx.

Icont bin/icont: src/h/define.h
		uname -a
		pwd
		cd src/common;		$(MAKE)
		cd src/rtt;		$(MAKE)
		cd src/icont;		$(MAKE)
		cd src/runtime;		$(MAKE) 


# The Icon program library.

Ilib:		bin/icont
		cd ipl;			$(MAKE) Ilib

Ibin:		bin/icont
		cd ipl;			$(MAKE) Ibin


##################################################################
#
# Installation and packaging.


# Installation:  "make Install dest=new-icon-directory"
#
# This will fail, intentionally, if the directory "dest" already exists.
# (That prevents several kinds of possible problems.)

D=$(dest)
Install:
		mkdir $D
		mkdir $D/bin $D/lib $D/doc $D/man $D/man/man1
		cp README $D
		cp bin/[cflpvwx]* $D/bin
		cp bin/icon[tx]* $D/bin
		rm -f $D/bin/libI*
		(cd $D/bin; ln -s icont icon)
		cp lib/*.* $D/lib
		cp doc/*.* $D/doc
		cp man/man1/*.* $D/man/man1


# Bundle up for binary distribution.

DIR=icon-package
Package:
		rm -rf $(DIR)
		umask 002; $(MAKE) Install dest=$(DIR)
		tar cf - $(DIR) | gzip -9 >$(DIR).tgz
		rm -rf $(DIR)


##################################################################
#
# Tests.

Test    Test-icont:	; cd tests; $(MAKE) Test
Samples Samples-icont:	; cd tests; $(MAKE) Samples


#################################################################
#
# Run benchmarks.

Benchmark Benchmark-icont:
		cd tests/bench;		$(MAKE) benchmark-icont

Micro Microbench Microbenchmark:
		cd tests/bench;		$(MAKE) microbenchmark


##################################################################
#
# Cleanup.
#
# "make Clean" removes intermediate files, leaving executables and library.
# "make Pure"  also removes binaries, library, and configured files.

Clean:
		touch Makedefs
		rm -rf icon-*
		cd src;			$(MAKE) Clean
		cd ipl;			$(MAKE) Clean
		cd tests;		$(MAKE) Clean

Pure:
		touch Makedefs
		rm -rf icon-*
		rm -rf bin/[abcdefghijklmnopqrstuvwxyz]*
		rm -rf lib/[abcdefghijklmnopqrstuvwxyz]*
		cd ipl;			$(MAKE) Pure
		cd src;			$(MAKE) Pure
		cd tests;		$(MAKE) Pure
		cd config; 		$(MAKE) Pure



#  (This is used at Arizona to prepare source distributions.)

Dist-Clean:
		rm -rf xx `find . -type d -name .git`
		rm -f  xx `find * -type f | xargs grep -l '<<ARIZONA-[O]NLY>>'`
		rm -f  xx `find . -type f -name '.??*' ! -name .placeholder`
		find . -type d | xargs chmod u=rwx,g=rwsx,o=rx
		find . -type f | xargs chmod ug=rw+X,o=r+X

=== config/Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
 #  Makefile for cleaning up after setup.sh
+.POSIX:
 
 TOP = ..
 SRC = $(TOP)/src

=== doc/Makefile ===
--- 
+++ 
@@ -5,6 +5,7 @@
 #  Because of that it is targeted for the Icon development environment
 #  (Mac OS X plus some specialized tools) and is less portable than
 #  other Makefiles.
+.POSIX:
 
 MADE = icon.txt icont.txt

=== ipl/Makefile ===
#  Makefile for the Icon Program Library
.POSIX:


All:	Ilib Ibin


#  Make a library distribution (portable ucode and include files).

Ilib:	cfuncs/libcfunc.so
cfuncs/libcfunc.so:  ../bin/icont
	cp incl/*.icn gincl/*.icn cfuncs/icall.h ../lib
	cd procs;  LPATH= ../../bin/icont -usc *.icn; mv *.u? ../../lib
	cd gprocs; LPATH= ../../bin/icont -usc *.icn; mv *.u? ../../lib
	if grep '^ *# *define LoadFunc' ../src/h/define.h >/dev/null; \
	   then $(MAKE) Cfunctions; fi


#  Make C functions.  Only called if LoadFunc is defined.

Cfunctions:
	cd cfuncs; LPATH= $(MAKE) ICONT=../../bin/icont
	cp cfuncs/*.u? ../lib
	rm -f ../bin/libcfunc.so
	cp cfuncs/libcfunc.so ../bin


#  Make selected graphics program binaries (platform-dependent icode)
#  for ../bin, given that ../lib is ready

Ibin:	gpacks/vib/vib
gpacks/vib/vib:  ../bin/icont
	MAKE=$(MAKE) ./BuildBin


#  Make a full set of program binaries (not usually done) in ./iexe,
#  given that ../lib is ready

Iexe:
	rm -f iexe/*
	MAKE=$(MAKE) ./BuildExe


#  Check for undefined identifiers in ../lib.
#  (A few are expected: references to Mp, program, init, goal).

Undef:
	cd ../lib; for f in *.u2; do (echo $$f; icont -us -fs $$f); done


#  Check for stray files

Strays:
	for d in *procs *progs *incl; do \
	    (cd $$d; pwd; ls -a | grep -vxE '\.|\.\.|.*\.icn'); \
	done; exit 0


#  Verify that all procedures and programs build, including packs,
#  and perform some other sanity checks

Check:
	./CheckAll


#  Make Zip files for separate distribution of the library

ZipFiles:  Ilib
	rm -rf ilib *.zip
	zip -qrX9 bipl.zip docs incl procs progs packs data cfuncs
	zip -qrX9 gipl.zip gdocs gincl gprocs gprogs gpacks gdata
	mkdir ilib
	cp ../lib/*.* ilib
	zip -qrX9 ilib.zip ilib
	rm -rf ilib


#  Clean up.

Clean Pure:
	-rm -rf ilib iexe *.zip */*.u[12] */*.zip */*.so *packs/*/*.exe
	-rm -f xx `find *procs *progs -type f ! -name '*.icn' -perm -100 -print`
	for d in cfuncs *packs/[abcdefghijklmnopqrstuvwxyz]*; do \
	    echo "+ cd ipl/$$d"; \
	    (cd $$d; $(MAKE) Clean 2>/dev/null) || echo "[not cleaned]"; done

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
 #  Icon source Makefile, normally used only for cleanup.
+.POSIX:
 
 
 what:

=== tests/Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
 #  Makefile for testing Icon
+.POSIX:
 
 
 #  The default is to run all tests.

=== ipl/cfuncs/Makefile ===
--- 
+++ 
@@ -2,6 +2,7 @@
 #
 #  If building with the compiler (instead of the interpreter)
 #  use the "-fs" option to avoid problems.
+.POSIX:
 
 
 include ../../Makedefs

=== src/common/Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+.POSIX:
+
 include ../../Makedefs

=== src/icont/Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
 #  Makefile for the Icon translator, icont.
+.POSIX:
 
 include ../../Makedefs

=== src/rtt/Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #  Makefile for the Icon run-time translator, rtt,
 #  which is used to build the Icon run-time system.
+.POSIX:
 
 include ../../Makedefs

=== src/runtime/Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
 #  Makefile for the Icon run-time system.
+.POSIX:
 
 include ../../Makedefs

=== src/wincap/Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
 # Makefile for creating a library of the parts of Wincap used by Icon.
+.POSIX:
 
 include ../../Makedefs

=== debian/changelog ===
icon (9.5.25a-2) unstable; urgency=medium

  * QA upload.
  * Drop patch 003-fix-ftbfs-with-glibc-2.28.patch: the underlying issue was
    fixed upstream already, and the patch changes the behaviour only on Haiku.
  * Fix the build on Hurd: upstream ship a "hurd" build configuration, so
    - drop the "gnu" build configuration from patch 001-debian-changes.patch
    - simplify setting the build name in debian/rules: assume that the needed
      one is the same as $DEB_HOST_ARCH_OS (in case it is not for future
      architectures, as simple override can be added)
    - backport the upstream PR https://github.com/gtownsend/icon/pull/11 to fix
      the existing "hurd" build configuration; patch
      Update-Hurd-build-configuration.patch

 -- Pino Toscano <pino@debian.org>  Sun, 21 Sep 2025 18:36:43 +0200

icon (9.5.25a-1) unstable; urgency=medium

  * QA upload.
  * New upstream version 9.5.25a
    + Support building with gcc-15 (Closes:1096826)
  * Adapt patch 001 to new version

 -- Mechtilde Stehmann <mechtilde@debian.org>  Tue, 09 Sep 2025 15:27:14 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: icon
 Maintainer: Debian QA Group <packages@qa.debian.org>
-Standards-Version: 4.7.0
+Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Section: devel
 Priority: optional
 Build-Depends: libx11-dev,

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,6 @@
 # Do we make iconx link with xpm.so?
 
 DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
-DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null)
 
 # The current code use type-punning and signed overflow
@@ -14,15 +13,7 @@
   CFLAGS_OPT = -O2 -fno-strict-aliasing -fno-strict-overflow
 endif
 
-ifneq (, $(filter $(DEB_HOST_ARCH_OS), linux kfreebsd knetbsd))
-  system = linux
-else
-  ifeq ($(DEB_HOST_ARCH_OS),hurd)
-    system = gnu
-  else
-    system = $(DEB_HOST_ARCH_OS)
-  endif
-endif
+system = $(DEB_HOST_ARCH_OS)
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
   CFLAGS_OPT = -O0
@@ -81,12 +72,11 @@
 #	cd debian/icont/usr/share/man/man1 && ln -sf icont.1.gz icont.real.1.gz
 # Fix permissions...
 	chmod -R u=rwX,go=rX debian/icont
-	chown -R root:root debian/icont
 # Make the debian control area.
 	dpkg-shlibdeps -pshlibs-icont debian/icont/usr/bin/*
 	dpkg-gencontrol -picont -Pdebian/icont
 # And finally, build the Debian package!
-	dpkg --build debian/icont ..
+	dpkg-deb --root-owner-group --build debian/icont ..
 
 binary-iconx: build-icont
 	rm -rf debian/iconx
@@ -107,12 +97,11 @@
 	gzip -9rn debian/iconx/usr/share/man
 # Fix permissions...
 	chmod -R u=rwX,go=rX debian/iconx
-	chown -R root:root debian/iconx
 # Make the debian control area.
 	dpkg-shlibdeps -pshlibs-iconx debian/iconx/usr/bin/*
 	dpkg-gencontrol -piconx -Pdebian/iconx
 # And finally, build the Debian package!
-	dpkg --build debian/iconx ..
+	dpkg-deb --root-owner-group --build debian/iconx ..
 
 binary-ipl: build-ipl
 	rm -rf debian/icon-ipl
@@ -133,11 +122,10 @@
 		xargs --no-run-if-empty gzip -9n
 # Fix permissions...
 	chmod -R u=rwX,go=rX debian/icon-ipl
-	chown -R root:root debian/icon-ipl
 # Make the debian control area.
 	dpkg-gencontrol -picon-ipl -Pdebian/icon-ipl
 # And finally, build the Debian package!
-	dpkg --build debian/icon-ipl ..
+	dpkg-deb --root-owner-group --build debian/icon-ipl ..
 
 test: build-icont build-ipl
 	@echo Tests for the Icon interpreter.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%$1.tar.gz%" \
   https://github.com/gtownsend/icon/tags \
   (?:.*?/)?v?(\d[\d\w.]*)\.tar\.gz debian uupdate
